Subject: Re: [PATCH v3 06/12] memory-hotplug: unregister memory section on SPARSEMEM_VMEMMAP

From: Jaegeuk Hanse <[email-masked]>
Date: Tue, 20 Nov 2012 19:03:30 +0800

On 11/20/2012 05:37 PM, Wen Congyang wrote:
> At 11/20/2012 02:58 PM, Jaegeuk Hanse Wrote:
>> On 11/20/2012 02:55 PM, Wen Congyang wrote:
>>> At 11/20/2012 02:22 PM, Jaegeuk Hanse Wrote:
>>>> On 11/01/2012 05:44 PM, Wen Congyang wrote:
>>>>> From: Yasuaki Ishimatsu <[email-masked]>
>>>>>
>>>>> Currently __remove_section for SPARSEMEM_VMEMMAP does nothing. But
>>>>> even if
>>>>> we use SPARSEMEM_VMEMMAP, we can unregister the memory_section.
>>>>>
>>>>> So the patch add unregister_memory_section() into __remove_section().
>>>> Hi Yasuaki,
>>>>
>>>> In order to review this patch, I should dig sparse memory codes in
>>>> advance. But I have some confuse of codes. Why need encode/decode mem
>>>> map instead of set mem_map to ms->section_mem_map directly?
>>> The memmap is aligned, and the low bits are zero. We store some
>>> information
>>> in these bits. So we need to encode/decode memmap here.
>> Hi Congyang,
>>
>> Thanks for you reponse. But I mean why return (unsigned long)(mem_map -
>> (section_nr_to_pfn(pnum))); in function sparse_encode_mem_map, and then
>> return ((struct page *)coded_mem_map) + section_nr_to_pfn(pnum); in
>> funtion sparse_decode_mem_map instead of just store mem_map in
>> ms->section_mep_map directly.
> I don't know why. I try to find the reason, but I don't find any
> place to use the pfn stored in the mem_map except in the decode
> function. Maybe the designer doesn't want us to access the mem_map
> directly.

It seems that mem_map is per node, but pfn is real pfn.
you can check __page_to_pfn.

>
> Thanks
> Wen Congyang
>
>> Regards,
>> Jaegeuk
>>
>>> Thanks
>>> Wen Congyang
>>>
>>>> Regards,
>>>> Jaegeuk
>>>>
>>>>> CC: David Rientjes <[email-masked]>
>>>>> CC: Jiang Liu <[email-masked]>
>>>>> CC: Len Brown <[email-masked]>
>>>>> CC: Christoph Lameter <[email-masked]>
>>>>> Cc: Minchan Kim <[email-masked]>
>>>>> CC: Andrew Morton <[email-masked]>
>>>>> CC: KOSAKI Motohiro <[email-masked]>
>>>>> CC: Wen Congyang <[email-masked]>
>>>>> Signed-off-by: Yasuaki Ishimatsu <[email-masked]>
>>>>> ---
>>>>>     mm/memory_hotplug.c | 13 ++++++++-----
>>>>>     1 file changed, 8 insertions(+), 5 deletions(-)
>>>>>
>>>>> diff --git a/mm/memory_hotplug.c b/mm/memory_hotplug.c
>>>>> index ca07433..66a79a7 100644
>>>>> --- a/mm/memory_hotplug.c
>>>>> +++ b/mm/memory_hotplug.c
>>>>> @@ -286,11 +286,14 @@ static int __meminit __add_section(int nid,
>>>>> struct zone *zone,
>>>>>     #ifdef CONFIG_SPARSEMEM_VMEMMAP
>>>>>     static int __remove_section(struct zone *zone, struct mem_section
>>>>> *ms)
>>>>>     {
>>>>> -    /*
>>>>> -     * XXX: Freeing memmap with vmemmap is not implement yet.
>>>>> -     *      This should be removed later.
>>>>> -     */
>>>>> -    return -EBUSY;
>>>>> +    int ret = -EINVAL;
>>>>> +
>>>>> +    if (!valid_section(ms))
>>>>> +        return ret;
>>>>> +
>>>>> +    ret = unregister_memory_section(ms);
>>>>> +
>>>>> +    return ret;
>>>>>     }
>>>>>     #else
>>>>>     static int __remove_section(struct zone *zone, struct mem_section
>>>>> *ms)
>>